package com.example.javafxopenwebinar;

import javafx.collections.FXCollections;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.control.TableColumn;
import javafx.scene.control.TableView;
import javafx.scene.control.cell.PropertyValueFactory;

import java.io.*;
import java.net.URL;
import java.nio.file.Files;
import java.util.ResourceBundle;

public class StudentController implements Initializable {

    @FXML
    private TableView<StudentModel> tbData;
    @FXML
    public TableColumn<StudentModel, Integer> studentId;
    @FXML
    public TableColumn<StudentModel, String> firstName;
    @FXML
    public TableColumn<StudentModel, String> lastName;

    @Override
    public void initialize(URL url, ResourceBundle resourceBundle) {

        /*Deserializar el archivo hecho en 8.2 por el fichero .dat del primer ejercicio */
        String fileToParse = "C:\\Users\\jandr\\Desktop\\Acceso a datos\\Container Ficheros\\FichPersona.dat";
        File file = new File(fileToParse);

        /*Creamos modelo objeto*/
        StudentModel student;

        /*Leemos archivo*/
        FileInputStream fIn;
        try {
            fIn = new FileInputStream(file);
        } catch (FileNotFoundException e) {
            throw new RuntimeException(e);
        }
        ObjectInputStream dataIS;
        try {
            dataIS = new ObjectInputStream(fIn);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }

        try {

            while (true) {
                /*Cogemos los datos y rellenamos las celdas*/
                student = (StudentModel) dataIS.readObject();
                studentId.setCellValueFactory(new PropertyValueFactory<>("studentId"));
                firstName.setCellValueFactory(new PropertyValueFactory<>("FirstName"));
                lastName.setCellValueFactory(new PropertyValueFactory<>("LastName"));
                tbData.setItems(FXCollections.observableArrayList(
                        new StudentModel(student.getStudentId(), student.getFirstName(), student.getLastName())
                ));
            }

        } catch (ClassNotFoundException | IOException error) {
            System.out.println(error.getMessage());
        }

        //Cerramos
        try { dataIS.close(); } catch (IOException e) { throw new RuntimeException(e); }

    }

}
